/*
 *   Copyright (C) 2000 Loic Dachary
 *
 *   This program is free software; you can redistribute it and/or modify it
 *   under the terms of the GNU General Public License as published by the
 *   Free Software Foundation; either version 2, or (at your option) any
 *   later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. 
 *
 */
/*
 * Simple dynamic loader. Assume that each loadable library follows
 * the conventions:
 *
 * libfoo.la implements only one class whose base class is
 * available to the main program.
 *
 * libfoo.la has a foo_init function.
 *
 * The foo_init function returns a pointer that holds function
 * pointers and data implemented by the library.
 */
#ifndef _webbasedl_h
#define _webbasedl_h

#ifdef __cplusplus
extern "C" {
#endif

typedef void* (*webbasedl_init_function_t)();

/*
 * Load library <name>, cache function pointer and return it.
 * If <name> was already loaded, return the cached function pointer.
 */
webbasedl_init_function_t webbasedl(const char* name);

#ifdef __cplusplus
}
#endif

#endif /* _webbasedl_h */
