/*
 *   Copyright (C) 1997, 1998, 1999 Loic Dachary
 *
 *   This program is free software; you can redistribute it and/or modify it
 *   under the terms of the GNU General Public License as published by the
 *   Free Software Foundation; either version 2, or (at your option) any
 *   later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. 
 *
 */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif /* HAVE_CONFIG_H */

#ifdef HAVE_UNISTD_H
#include <unistd.h>
#endif /* HAVE_UNISTD_H */
#include <stdlib.h>
#include <stdio.h>
#include <fcntl.h>

#include <write_file.h>

static void write_file_1(char* path, char* data, int size, int mode);

void write_file(char* path, char* data, int size)
{
  write_file_1(path, data, size, O_WRONLY | O_TRUNC | O_CREAT);
}

void append_file(char* path, char* data, int size)
{
  write_file_1(path, data, size, O_WRONLY | O_APPEND);
}

static void write_file_1(char* path, char* data, int size, int mode)
{
  int fd;
  int r;

  if((fd = open(path, mode, 0666)) < 0) {
    fprintf(stderr, "could not open %s\n", path);
    perror("");
    exit(1);
  }

  if((r = write(fd, data, size)) != size) {
    fprintf(stderr, "%s only write %d bytes out of %d\n", path, r, size);
    perror("");
    exit(1);
  }
  close(fd);
}
